# ***********************************************
# 
# !!!! DO NOT EDIT !!!!
# 
# This file was auto-generated by Build.PL.
# 
# ***********************************************
# 
# Licensed to the Apache Software Foundation (ASF) under one or more
# contributor license agreements.  See the NOTICE file distributed with
# this work for additional information regarding copyright ownership.
# The ASF licenses this file to You under the Apache License, Version 2.0
# (the "License"); you may not use this file except in compliance with
# the License.  You may obtain a copy of the License at
# 
#     http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

=encoding utf8

=head1 NAME

Lucy::Index::SegReader - Single-segment IndexReader.

=head1 SYNOPSIS

    my $polyreader = Lucy::Index::IndexReader->open(
        index => '/path/to/index',
    );
    my $seg_readers = $polyreader->seg_readers;
    for my $seg_reader (@$seg_readers) {
        my $seg_name = $seg_reader->get_seg_name;
        my $num_docs = $seg_reader->doc_max;
        print "Segment $seg_name ($num_docs documents):\n";
        my $doc_reader = $seg_reader->obtain("Lucy::Index::DocReader");
        for my $doc_id ( 1 .. $num_docs ) {
            my $doc = $doc_reader->fetch_doc($doc_id);
            print "  $doc_id: $doc->{title}\n";
        }
    }

=head1 DESCRIPTION

SegReader interprets the data within a single segment of an index.

Generally speaking, only advanced users writing subclasses which manipulate
data at the segment level need to deal with the SegReader API directly.

Nearly all of SegReader’s functionality is implemented by pluggable
components spawned by L<Architecture|Lucy::Plan::Architecture>’s
factory methods.

=head1 METHODS

=head2 get_seg_name

    my $string = $seg_reader->get_seg_name();

Return the name of the segment.

=head2 get_seg_num

    my $int = $seg_reader->get_seg_num();

Return the number of the segment.

=head2 del_count

    my $int = $seg_reader->del_count();

Return the number of documents which have been marked as deleted but
not yet purged from the index.

=head2 doc_max

    my $int = $seg_reader->doc_max();

Return the maximum number of documents available to the reader, which
is also the highest possible internal document id.  Documents which
have been marked as deleted but not yet purged from the index are
included in this count.

=head2 doc_count

    my $int = $seg_reader->doc_count();

Return the number of documents available to the reader, subtracting
any that are marked as deleted.

=head2 _offsets

    my $i32_array = $seg_reader->_offsets();

Return an array with one entry for each segment, corresponding to
segment doc_id start offset.

=head2 seg_readers

    my $arrayref = $seg_reader->seg_readers();

Return an array of all the SegReaders represented within the
IndexReader.

=head1 INHERITANCE

Lucy::Index::SegReader isa L<Lucy::Index::IndexReader> isa L<Lucy::Index::DataReader> isa Clownfish::Obj.

=cut

